import java.io.*;
import java.util.*;

public class gen {
    public static void main( String argv[] ) {
        try {
            String data_file = "sample.txt";
            String command_file = "pdfgensample5.txt";
            String log_file = "err.txt";

            int MaxLines = 50;
            String Lines[] = new String[50];
            int LastLine, Counter;

            FileInputStream fis = new FileInputStream(data_file);
            InputStreamReader ir = new InputStreamReader(fis, "MS932");
            BufferedReader objInFile = new BufferedReader(ir);

            FileOutputStream fos = new FileOutputStream(command_file);
            OutputStreamWriter ow = new OutputStreamWriter(fos, "MS932"); 
            BufferedWriter objOutFile = new BufferedWriter(ow);

            objOutFile.write("FastPDFGen\tDEMO.FASTWIN::2024/09/21::014BD04C17A29CB5A8AC9860F7067889\n");
            objOutFile.write("compressField\n");
            objOutFile.write("start\tpdfgensample5_r.pdf\n");

            LastLine = 0;
            Counter = 1;
            while((Lines[LastLine] = objInFile.readLine()) != null) {
                LastLine++;
                if (LastLine >= MaxLines) {
                    PrintPage(objOutFile, Lines, LastLine, Counter);
                    LastLine = 0;
                }
            }

            if (LastLine > 0) {
                PrintPage(objOutFile, Lines, LastLine, Counter);
            }

            objOutFile.write("finish");
            objOutFile.close();

            Runtime runtime = Runtime.getRuntime();
            Process process = runtime.exec("FastPDFGen.exe " + command_file + " " + log_file + "\n");
        }
        catch(IndexOutOfBoundsException e) {
            System.out.println(e.toString());
            System.exit(-1);
        }
        catch(Exception e) {
            System.out.println(e.toString());
            System.exit(-1);
        }
    }


    public static void PrintPage(BufferedWriter objOutFile, String Lines[], int LastLine, int Counter) {
        try {
            int DispLineNo, LineNo;

            int DrawPointX = 85;
            int DrawPointY = 135;
            int BoxWidth = 310;
            int LineHeight = 12;
            int HeaderHeight = 23;
            int DrawPointItem2 = 67;
            int DrawPointItem3 = 217;

            objOutFile.write("startPage\tpdfgensample5.pdf.tpl\n");

            objOutFile.write("drawBox\t" + DrawPointX + "\t" + DrawPointY + "\t" + BoxWidth + "\t" + (HeaderHeight + LineHeight * LastLine + 1) + "\t0.6\t1\t0\t0\t0\n");

            objOutFile.write("drawLine\t" + DrawPointX + "\t" + (DrawPointY + HeaderHeight - 4) + "\t" + BoxWidth + "\t0\t0.3\t1\t0\t0\t0\n");
            objOutFile.write("drawLine\t" + DrawPointX + "\t" + (DrawPointY + HeaderHeight - 2) + "\t" + BoxWidth + "\t0\t0.3\t1\t0\t0\t0\n");

            for (LineNo = 1; LineNo < LastLine; LineNo++) {
                objOutFile.write("drawLine\t" + DrawPointX + "\t" + (DrawPointY + HeaderHeight + LineHeight * LineNo) + "\t" + BoxWidth + "\t0\t0.2\t1\t0\t0\t0\n");
            }

            objOutFile.write("drawLine\t" + (DrawPointX + DrawPointItem2) + "\t" + DrawPointY + "\t0\t" + (HeaderHeight + LineHeight * LastLine + 1) + "\t0.2\t1\t0\t0\t0\n");
            objOutFile.write("drawLine\t" + (DrawPointX + DrawPointItem3) + "\t" + DrawPointY + "\t0\t" + (HeaderHeight + LineHeight * LastLine + 1) + "\t0.2\t1\t0\t0\t0\n");

            objOutFile.write("makeArrayPageField\titem1\t" + LastLine + "\t" + LineHeight + "\n");
            objOutFile.write("makeArrayPageField\titem2\t" + LastLine + "\t" + LineHeight + "\n");
            objOutFile.write("makeArrayPageField\titem3\t" + LastLine + "\t" + LineHeight + "\n");

            objOutFile.write("setPageFieldData\tdate\t2023/12/25\n");
            objOutFile.write("setPageFieldData\ttitle1\tNo.\n");
            objOutFile.write("setPageFieldData\ttitle2\t名称\n");
            objOutFile.write("setPageFieldData\ttitle3\t日付\n");

            for (LineNo = 0; LineNo < LastLine; LineNo++) {
                DispLineNo = LineNo + 1;
                StringTokenizer st = new StringTokenizer(Lines[LineNo], ",");
                String Items0 = st.nextToken().toString();
                String Items1 = st.nextToken().toString();

                objOutFile.write("setPageFieldData\titem1__" + DispLineNo + "\t" + Counter + "\n");
                objOutFile.write("setPageFieldData\titem2__" + DispLineNo + "\t" + Items0 + "\n");
                objOutFile.write("setPageFieldData\titem3__" + DispLineNo + "\t" + Items1 + "\n");
                Counter++;
            }

            objOutFile.write("endPage\n");
        }
        catch(IndexOutOfBoundsException e) {
            System.out.println(e.toString());
            System.exit(-1);
        }
        catch(Exception e) {
            System.out.println(e.toString());
            System.exit(-1);
        }
    }
}
